package com.example.processor

import com.google.devtools.ksp.getClassDeclarationByName
import com.google.devtools.ksp.processing.CodeGenerator
import com.google.devtools.ksp.processing.KSPLogger
import com.google.devtools.ksp.processing.Resolver
import com.google.devtools.ksp.processing.SymbolProcessor

class MyProcessor : SymbolProcessor {
    lateinit var codeGenerator: CodeGenerator
    override fun finish() {

    }

    override fun init(
        options: Map<String, String>,
        kotlinVersion: KotlinVersion,
        codeGenerator: CodeGenerator,
        logger: KSPLogger
    ) {
        this.codeGenerator = codeGenerator
    }

    override fun process(resolver: Resolver) {
        val generatedJ9 = resolver.getClassDeclarationByName("javax.annotation.processing.Generated")
        val generatedAnnotationIfAvailable = if (generatedJ9 != null) {
            "@${generatedJ9.qualifiedName!!.asString()}"
        } else {
            ""
        }
        val output = """
            $generatedAnnotationIfAvailable
            class ProcessorGenerated {
                
            }
        """.trimIndent()
        codeGenerator.createNewFile("", "ProcessorGenerated.kt").use {
            it.writer(Charsets.UTF_8).use {
                it.write(output)
            }
        }
    }
}